<template>

  <Head>
    <title>Add New User - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow">
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-user me-2"></i> ADD NEW USER</span>
              </div>
              <div class="card-body">

                <form @submit.prevent="submit">
                  <!-- full name -->
                  <div class="mb-3">
                    <label class="fw-bold">Full Name</label>
                    <input class="form-control" v-model="form.name" :class="{ 'is-invalid': errors.name }" type="text"
                      placeholder="Full Name">
                  </div>
                  <div v-if="errors.name" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.name }}</strong></small>
                  </div>

                  <!-- email address -->
                  <div class="mb-3">
                    <label class="fw-bold">Email Address</label>
                    <input class="form-control" v-model="form.email" :class="{ 'is-invalid': errors.email }"
                      type="email" placeholder="Email Address">
                  </div>
                  <div v-if="errors.email" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.email }}</strong></small>
                  </div>

                  <!-- password -->
                  <div class="mb-3">
                    <label class="fw-bold">Password</label>
                    <input class="form-control" v-model="form.password" :class="{ 'is-invalid': errors.password }"
                      type="password" placeholder="Password">
                  </div>
                  <div v-if="errors.password" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.password }}</strong></small>
                  </div>

                  <!-- password confirmation -->
                  <div class="mb-3">
                    <label class="fw-bold">Password Confirmation</label>
                    <input class="form-control" v-model="form.password_confirmation" type="password"
                      placeholder="Password Confirmation">
                  </div>

                  <!-- roles -->
                  <div class="row">
                    <div class="col-md-12">
                      <div class="mb-3">
                        <label class="fw-bold">Roles</label>
                        <br>
                        <div class="form-check form-check-inline" v-for="(role, index) in roles" :key="index">
                          <input class="form-check-input my-1 ms-1" type="checkbox" v-model="form.roles"
                            :value="role.name" :id="`check-${role.id}`">
                          <label class="form-check-label" :for="`check-${role.id}`">{{
                            role.name
                          }}</label>
                        </div>
                      </div>
                      <div v-if="errors.roles" class="text-danger mb-3" style="margin-top: -15px">
                        <small><strong>{{ errors.roles }}</strong></small>
                      </div>
                    </div>
                  </div>

                  <!-- button submit-->
                  <div class="row">
                    <div class="col-12">
                      <button class="btn btn-primary shadow-sm rounded" type="submit">
                        SAVE
                      </button>
                    </div>
                  </div>
                </form>

              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue';

//import Heade and useForm from Inertia
import { Head, Link } from '@inertiajs/vue3';

// import reactive from vue
import { reactive } from 'vue';

// import inerita adapter
import { router } from '@inertiajs/vue3';

// import sweet alert2
import Swal from 'sweetalert2';

export default {
  // layout
  layout: LayoutApp,

  // register component
  components: {
    Head,
    Link
  },

  // props
  props: {
    errors: Object,
    roles: Array,
  },

  // composition API
  setup() {

    // define form with reactive
    const form = reactive({
      name: '',
      email: '',
      password: '',
      password_confirmation: '',
      roles: []
    });

    // method "submit"
    const submit = () => {

      // send data to server
      router.post('/apps/users', {
        // data
        name: form.name,
        email: form.email,
        password: form.password,
        password_confirmation: form.password_confirmation,
        roles: form.roles
      }, {
        onSuccess: () => {
          // show success alert
          Swal.fire({
            title: 'Created!',
            text: 'User has been created.',
            icon: 'success',
            showConfirmButton: false,
            timer: 2000
          });
        },
      });

    }

    // return
    return {
      form,
      submit,
    };

  }
}
</script>

<style>

</style>